/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef CLI_LOG_H
#define CLI_LOG_H

#include "common/global/log.h"

namespace Log
{

class ConsoleView : public View
{
public:
  static void init(bool interactive);
  static ConsoleView &self() { return *_self; }
  virtual void appendToLastLine(const QString &text);
  virtual void clear() {}
  virtual void sorry(const QString &message, const QString &details);
  virtual bool askContinue(const QString &message);

private:
  bool _interactive;
  virtual void doLog(Type type, const QString &text, Action action);
  virtual void doLog(DebugLevel level, const QString &text, Action action);

  static ConsoleView *_self;
};

} // namespace

#endif
