/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef CONFIG_GEN_H
#define CONFIG_GEN_H

class QHBoxLayout;
class QComboBox;
class QLabel;

#include "common/gui/dialog.h"
#include "tools/base/tool.h"
namespace DeviceChooser { class Button; }
namespace Device {
  class Memory;
  class MemoryEditor;
}
class SimpleTextEditor;

class ConfigGenerator : public Dialog
{
Q_OBJECT
public:
  ConfigGenerator(const Device::Data *data, const Tool::Group &group, PURL::ToolType stype, QWidget *parent);
  virtual ~ConfigGenerator();
  void set(const Device::Data *data, const Tool::Group &group, PURL::ToolType stype);

private slots:
  void typeChanged();
  void set();
  void computeConfig();
  virtual void slotUser1();

private:
  Device::Memory    *_memory;
  QHBoxLayout       *_hbox;
  DeviceChooser::Button *_deviceChooser;
  QComboBox         *_configType, *_toolType;
  Device::MemoryEditor *_configEditor;
  SimpleTextEditor  *_text;
  QLabel            *_warning;

  void setToolType(PURL::ToolType stype);
};

#endif
