/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DEVICE_EDITOR_H
#define DEVICE_EDITOR_H

#include "editor.h"
namespace Device { class Data; }

class DeviceEditor : public Editor
{
Q_OBJECT
public:
  DeviceEditor(Capabilities capabilities, const QString &title, const QString &tag, QWidget *parent, const char *name);
  DeviceEditor(Capabilities capabilities, const PURL::Url &url, QWidget *parent, const char *name);
  virtual void configureEditor() {}
  virtual void setFocus() {}
  virtual void setCursor(uint, uint) {}
  virtual bool state(ValueType type) const;
  virtual void setState(ValueType, bool) {}
  virtual PURL::FileType fileType() const { return PURL::Nb_FileTypes; }

  virtual void setDevice(bool force = false);
  static QString guessDeviceFromFile(const PURL::Url &url);

public slots:
  virtual void statusChanged() { emit statusTextChanged("  "); }

protected:
  QString      _device;
  QWidget     *_widget, *_view;
  QVBoxLayout *_top, *_vbox;
  QLabel      *_labelDevice, *_labelWarning;

  void init();
  virtual QWidget *createView(const Device::Data *data, QWidget *parent) = 0;
  virtual bool load() { return true; }
  virtual bool save(const PURL::Url &) const { return false; }
  static PURL::Url findAsmFile(const PURL::Url &url);

private slots:
  void updateDevice() { setDevice(); }
};

#endif
