/***************************************************************************
 *   Copyright (C) 2006 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef OBJECT_VIEW_H
#define OBJECT_VIEW_H

#include "text_editor.h"
namespace Device { class Data; }
class HexEditor;

namespace Coff
{
class TextObject;

//-----------------------------------------------------------------------------
class Editor : public SimpleTextEditor, public Log::Base
{
Q_OBJECT
public:
  Editor(const PURL::Url &url, const Device::Data &data, Log::Base &log, QWidget *parent);
  Editor(const PURL::Url &url, const TextObject &object, QWidget *parent);
  virtual ~Editor();

private:
  TextObject *_created;
  const TextObject *_provided;

  virtual bool load();
};

} // namespace

//-----------------------------------------------------------------------------
class DisassemblyEditor : public SimpleTextEditor, public Log::Base
{
Q_OBJECT
public:
  DisassemblyEditor(const PURL::Url &url, const PURL::Url &hexUrl, const Device::Data &data, QWidget *parent);
  DisassemblyEditor(const PURL::Url &url, const HexEditor &e, const Device::Data &data, QWidget *parent);
  virtual PURL::FileType fileType() const { return PURL::AsmGPAsm; }

private:
  const Device::Data &_data;
  PURL::Url                _hexUrl;
  const HexEditor    *_editor;

  virtual bool load();
};


#endif
