/***************************************************************************
 *   Copyright (C) 2003-2005 Alain Gibaud <alain.gibaud@free.fr>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "direct_18.h"

void Direct::P18::send_word(uint d)
{
    hardware().setWrite();
    for (uint x = 0; x<16; x++) {
        hardware().setPin(Clock, High);
        if ( d & 0x01 ) hardware().setPin(DataOut, High);
        else hardware().setPin(DataOut, Low);
        Port::usleep(_clockDelay+5);
        hardware().setPin(Clock, Low);
        Port::usleep(_clockDelay+3);
        d >>= 1;                    // Move the data over 1 bit
    }
    hardware().setPin(DataOut, High);
    hardware().setRead();
}

uint Direct::P18::get_word()
{
    hardware().setRead();
    uint ind = 0;
    send_cmd(9);
    hardware().setPin(DataOut, High);
    for (uint x = 0; x<16; x++) {
        hardware().setPin(Clock, High);
        Port::usleep(_clockDelay+5);
        if ( x>7 && hardware().readBit() ) ind |= (1 << x-8);
        hardware().setPin(Clock, Low);
        Port::usleep(_clockDelay+3);
    }
    send_cmd(9);
    hardware().setPin(DataOut, High);
    for (uint x = 0; x<16; x++) {
        hardware().setPin(Clock, High);
        Port::usleep(_clockDelay+5);
        if ( x>7 && hardware().readBit() ) ind |= (1 << x);
        hardware().setPin(Clock, Low);
        Port::usleep(_clockDelay+3);
    }
    return ind;
}

uint Direct::P18::get_byte()
{
    hardware().setRead();
    uint ind = 0;
    send_cmd(2);
    hardware().setPin(DataOut, High);
    for (uint x = 0; x<16; x++) {
        hardware().setPin(Clock, High);
        Port::usleep(_clockDelay+5);
        if ( x>7 && hardware().readBit() ) ind |= (1 << x-8);
        hardware().setPin(Clock, Low);
        Port::usleep(_clockDelay+3);
    }
    return ind;
}

void Direct::P18::send_bits(uint d, uint nbb)
{
    hardware().setWrite();
    for (int x = nbb; x; --x) {
        hardware().setPin(Clock, High);
        if ( d & 0x01 ) hardware().setPin(DataOut, High);
        else hardware().setPin(DataOut, Low);
        Port::usleep(_clockDelay+5);
        hardware().setPin(Clock, Low);
        Port::usleep(_clockDelay+3);
        d >>= 1;  // Move the data over 1 bit
    }
    hardware().setPin(DataOut, High);
    hardware().setRead();
}
