/***************************************************************************
 *   Copyright (C) 2005 Nicolas Hadacek <hadacek@kde.org>                  *
 *   Copyright (C) 2003-2005 Alain Gibaud <alain.gibaud@free.fr>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DIRECT_PROG_CONFIG_H
#define DIRECT_PROG_CONFIG_H

#include <qstringlist.h>

#include "common/port/port.h"
#include "direct.h"
#include "common/global/generic_config.h"

namespace Direct
{
  struct HardwareData {
    Port::Type portType;
    Hardware::HData data;
  };
  struct StandardHardwareData {
    const char *name, *label, *comment;
    HardwareData hdata;
  };

class Config : public GenericConfig
{
public:
  Config() : GenericConfig("direct_programmer") {}
  QStringList hardwareNames(Port::Type type);
  bool isStandardHardware(const QString &name) { return standardHardwareData(name)!=0; }
  const StandardHardwareData *standardHardwareData(const QString &name);
  HardwareData hardware(const QString& name);
  void writeCustomHardware(const QString &name, const HardwareData &data);
  QString currentHardware(Port::Type type);
  void writeCurrentHardware(Port::Type type, const QString &name);
  void deleteCustomHardware(const QString &name);

private:
  static const StandardHardwareData STANDARD_HARDWARE_DATA[];
};

} //namespace

#endif
