/***************************************************************************
 *   Copyright (C) 2005-2006 Nicolas Hadacek <hadacek@kde.org>             *
 *   Copyright (C) 2002-2003 Stephen Landamore <stephen@landamore.com>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "progs/icd2/base/icd2_data.h"

// for MPLAB 7.21 - 7.41
const Icd2::FirmwareData Icd2::FIRMWARE_DATA[Nb_Firmwares] = {
  {{ 2,  6,  5 }, { 2, 7, 0 }}, // 01
  {{ 0,  0,  0 }, { 0, 0, 0 }}, // 02 [none]
  {{ 0,  0,  0 }, { 0, 0, 0 }}, // 03 [none]
  {{ 2,  6,  6 }, { 2, 6, 8 }}, // 04
  {{ 1,  2,  5 }, { 1, 3, 9 }}, // 05
  {{ 1,  2,  2 }, { 1, 2, 2 }}, // 06
  {{ 1,  2,  9 }, { 1, 4, 0 }}, // 07
  {{ 1,  3,  4 }, { 1, 5, 0 }}, // 08
  {{ 1,  0,  0 }, { 1, 0, 0 }}, // 09
  {{ 1,  3,  1 }, { 1, 4, 4 }}, // 10
  {{ 0,  0, 27 }, { 1, 0, 4 }}, // 11
  {{ 1,  2,  0 }, { 1, 2, 0 }}, // 12
  {{ 0,  0,  0 }, { 0, 0, 0 }}, // 13 [none]
  {{ 0,  0,  0 }, { 2, 0, 6 }}, // 14
  {{ 0,  0,  0 }, { 1, 1, 0 }}  // 15
};

const Icd2::FamilyData Icd2::FAMILY_DATA[] = {
  { "12F629",       1, "12F629"  }, // 12F629/675
  { "16F676",       1, "16F676"  }, // 16F630/676
  { "16F648A",      1, "16F648A" }, // 16F627A/628A/648A
  { "16F716",       1, "16F716"  },
  { "16F7X7",       1, "16F7X7"  }, // 16F737/747/767/777
  { "16F819",       1, "16F819"  }, // 16F818/819
  { "16F88",        1, "16F88"   }, // 16F87/88
  { "16F872",       1, "16F872"  }, // 16F870/871/872
  { "16F874",       1, "16F874"  }, // 16F873/873A/874/874A
  { "16F877",       1, "16F877"  }, // 16F876/876A/877/877A
  { "16F7X",        1, 0         }, // 16F73
  { 0,              2, 0         }, // 30F for revision A2 (legacy: not in MPLAB 7)
  { 0,              3, "30F"     }, // 30F for revision A3/B0 (legacy: not in MPLAB 7)
  { "18F_4",        4, ""        }, // debug executive filename is computed at runtime
  { "18F_5",        5, ""        }, // debug executive filename is computed at runtime
  { "18CX01",       6, 0},//"18CX01"   }, // 16C601/801
  { "10F2XX",       7, 0         },
  { "16F5X",        7, 0         },
  { "12F635",       8, "12F635"  }, // 12F635/683 16F636/639
  { "16F685",       8, 0         }, // 16F685/687/689/690
  { "16F785",       8, 0         }, // 16F785 (debug exec ?)
  { "16F916",       8, "16F916"  }, // 16F913/914/916/917
  { "16F684",       8, "16F684"  },
  { "16F688",       8, "16F688"  },
  { "16F629",       9, 0         },
  { "30F",         10, 0},//"30F_REVB" }, // 30F revision B1 and above
  { "16FX7J",      11, 0         }, // 18F67J/87J
  { "16F72",       12, 0         }, // 16F72/8X/627/628/84A
  { "24F",         14, 0},//"24F"      }, // from MPLAB 7.3
  { "33F",         14, 0},//"33F"      }, // from MPLAB 7.3
  { "16F61X",      15, 0         }, // 12F61X/16F61X

  { 0,              0, 0         }
};
